#include <iostream>
#include <assert.h>
#include "bitmap.h"
#include<string>
#include<time.h>
#include<stdlib.h>
#include<stdio.h>
#include<randint.h>
#include "rect.h"
//Declaration of different window for display
	float tank_x, tank_y;
	float othertank_x, othertank_y;

SimpleWindow PTw("POCKET TANKS",28.0,21.0);
SimpleWindow w2("Option Selection",28.0,21.0);
SimpleWindow w3("INSTRUCTION",28.0,21.0);
SimpleWindow w4("Playing Parameters",28.0,21.0);
SimpleWindow w5("EXIT TO GAME",28.0,21.0);
//Declaration of different bitmaps to be used 
BitMap pocket_tank(PTw),tank1(PTw),tank2(PTw),Exit(w2),player1(w2),player2(w2),background2(w2),aboutgame(w2),instruction(w2),aboutinstruction(w3),back1(w3),gaming(w4),aboutgaming(w4),back2(w4),exitscreen(w5),loading1(PTw),loading2(w2),loading3(w3),loading4(w4);
BitMap background(PTw);
int PTwMouseClick1(const Position &);
int PTwMouseClick2(const Position &);
int PTwMouseClick3(const Position &);
int PTwMouseClick4(const Position &);
void oneplayergame();
void twoplayergame();		//This function will invoke the two player game
void screen2();			//This function is used for display of screen2
void Load_BitMap(BitMap &Image,const Position &Pos)
{
	assert(Image.GetStatus() == BitMapOkay);
	Image.SetPosition(Pos);	
	Image.Draw();
}
//This function execute for mouseclick of screen2
int PTwMouseClick2(const Position &p)
{
	if(instruction.IsInside(p) )		//Calling of instruction bitmap
	{
		w2.Close();
		w3.Open();
		assert(w3.GetStatus() == WindowOpen);
		w3.RenderRectangle(Position(0.0, 0.0), Position(28.0,21.0),Blue, true);
		loading3.Load("loading3.xpm");
		Load_BitMap(loading3,Position(8.5,6.0));			
		aboutinstruction.Load("aboutinstruction.xpm");
		Load_BitMap(aboutinstruction,Position(-0.5,-1.0));
		back1.Load("back1.xpm");
		Load_BitMap(back1,Position(12.5,19.6));
		w3.SetMouseClickCallback(PTwMouseClick3);
	}
	if(aboutgame.IsInside(p) )		//Calling of aboutgame bitmap
	{
		w2.Close();
		w4.Open();
		assert(w4.GetStatus() == WindowOpen);
		w4.RenderRectangle(Position(0.0, 0.0), Position(28.0,21.0),Blue, true);
		loading4.Load("loading4.xpm");
		Load_BitMap(loading4,Position(8.5,6.0));			
		aboutgaming.Load("aboutgaming.xpm");
		Load_BitMap(aboutgaming,Position(-1.3,-2.0));
		gaming.Load("gaming.xpm");
		Load_BitMap(gaming,Position(12.5,1.0));
		back2.Load("back2.xpm");
		Load_BitMap(back2,Position(12.5,19.6));
		w4.SetMouseClickCallback(PTwMouseClick4);
	}
	if(Exit.IsInside(p) )		//Calling of Exit bitmap
	{
		w2.Close();
		w5.Open();
		assert(w5.GetStatus() == WindowOpen);
		exitscreen.Load("exitscreen.xpm");
		Load_BitMap(exitscreen,Position(5.0,5.0));
		w5.Close();
	}
	if(player2.IsInside(p) )		//Calling of player2 bitmap
	{
		w2.Close();
		twoplayergame(); 
	}
	if(player1.IsInside(p) )		//Calling of player1 bitmap
	{
		w2.Close();
		oneplayergame(); 
	}
		
return 1;		
	
}
//Description of screen 2
void screen2()
{
	
	//Colors available with us: {White, Red, Green, Blue, Yellow, Cyan, Magenta};
	
	Exit.Load("exit.xpm");
	player1.Load("player1.xpm");
	player2.Load("player2.xpm");
	background2.Load("background2.xpm");
	aboutgame.Load("aboutgame.xpm");
	instruction.Load("instruction.xpm");
	Load_BitMap(loading2,Position(8.5,6.0));
	Load_BitMap(background2,Position(0.0,0.0));
	Load_BitMap(player1,Position(11.4,5.0));
	Load_BitMap(player2,Position(11.2,7.5));	
	Load_BitMap(aboutgame,Position(10.6,9.5));
	Load_BitMap(instruction,Position(11.6,12.5));
	Load_BitMap(Exit,Position(11.4,14.5));
	w2.SetMouseClickCallback(PTwMouseClick2);
	
	
}
//Mouse click effect for screen 1
int PTwMouseClick1(const Position &p)
{ 
	if(background.IsInside(p) )
	{
		PTw.Close();	
		w2.Open();
  		assert(w2.GetStatus() == WindowOpen);
		w2.RenderRectangle(Position(0.0, 0.0), Position(28.0,21.0),Blue, true);
		loading2.Load("loading2.xpm");
		Load_BitMap(loading2,Position(8.5,6.0));			
		screen2();	
	}
	return 1;
}
//Mouseclick effect for back option
int PTwMouseClick3(const Position &p)
{ 
	if(back1.IsInside(p) )
	{
		w3.Close();	
		w2.Open();
  		assert(w2.GetStatus() == WindowOpen);
		w2.RenderRectangle(Position(0.0, 0.0), Position(28.0,21.0),Blue, true);
		loading2.Load("loading2.xpm");
		Load_BitMap(loading2,Position(8.5,6.0));		
		screen2();
	}
	return 1;
}
//Mouseclick effect for another back option
int PTwMouseClick4(const Position &p)
{ 
	if(back2.IsInside(p) )
	{
		w4.Close();	
		w2.Open();
  		assert(w2.GetStatus() == WindowOpen);
		w2.RenderRectangle(Position(0.0, 0.0), Position(28.0,21.0),Blue, true);
		loading2.Load("loading2.xpm");
		Load_BitMap(loading2,Position(8.5,6.0));		
		screen2();
	}
	return 1;
}


int player_1_score=0,player_2_score=0;						//scores of players
float blastx, blasty;								//tracks where weapon blasts, for scoring purpose
int power_pp=0, angle_pp=0;							//initial score and angle are zero
int weapon_index=0;								//knows which weapon to fire
int fire_check=0;								//chech to end the game after each player has fired all his shots.
//tank1x,tank1y,tank2x,tank2y are meant to keep the coordinates of tanks. Initiated while terrain drawn.

//counter_tank will keep track which tank will shoot now
int counter_tank=1;								//initial value is 1
										//counter changed after score is updated

int wind;									//global variable for wind
void wind_gen();								//prototype of function(has to be declared after includef.cpp

#include"includef.cpp"								//contains header files to be included







void wind_gen(){								//generates random wind
BitMap windimg(w);
windimg.Load("wind.xpm");

	wind+=rand()%41-20;
		    wind=abs(wind)<=100?wind:100*abs(wind)/wind;
										//this ensures wind does'nt change drastically on two consecutive shots
	displaynum(13,2,wind,White);						//displays wind on screen
	windimg.SetPosition(Position(12.5,0.5));	
	windimg.Draw();
}



//int player_1_score=0,player_2_score=0;  //global declaration of scores make things easier, not to pass values!!!
//the above declaration has been placed in scoreupdate.cpp, due to compilation error reasons
//   float tank1x,tank1y,tank2x,tank2y;		//coordinates of two tanks, for knowing where to fire from (DECLARED IN terrain.cpp)



void twoplayergame(){
   weapon_select();			//selection of weapons by two players
//the game goes by going from function to function, so only first one neds to be called here
}
#include "oneplayergame.cpp"
int ApiMain()
{
	PTw.Open();
  	assert(PTw.GetStatus() == WindowOpen);
	loading1.Load("loading1.xpm");	
	//Colors available with us: {White, Red, Green, Blue, Yellow, Cyan, Magenta};
	PTw.RenderRectangle(Position(0.0, 0.0), Position(28.0,21.0),Blue, true);
	Load_BitMap(loading1,Position(8.5,6.0));
	
	pocket_tank.Load("pockettank.xpm");
	tank1.Load("tank1.xpm");
	tank2.Load("tank2.xpm");
	background.Load("background.xpm");	
	Load_BitMap(background,Position(0.0,0.0));
	//This all is for showing the effectof bombs(just pictures)
	PTw.RenderEllipse(Position(14.0,14.0),Position(15.0,15.0),Black,false);
	PTw.RenderEllipse(Position(15.2,14.5),Position(15.9,15.2),Black,false);
	PTw.RenderEllipse(Position(16.3,15.0),Position(16.8,15.5),Black,false);	
	PTw.RenderEllipse(Position(17.3,15.4),Position(17.7,15.8),Black,false);			
	Load_BitMap(pocket_tank,Position(4.8,5.8));
	Load_BitMap(tank2,Position(0.0,16.5));
	Load_BitMap(tank1,Position(23.7,16.5));
	PTw.SetMouseClickCallback(PTwMouseClick1);
	return 0;
}
