/*this programme(SINGLE PLAYER) uses concept of classes maintain variables and run the game*/

#include<iostream>
#include<fstream>
#include<math.h>
#include<string.h>
#include<assert.h>
#include"ezwin.h"
#include"bitmap.h"
#include"nuke.cpp"
#include"acidrain.cpp"
#include"shower.cpp"
#include"skipper.cpp"
#include"wall.cpp"
#include"zapper.cpp"
#include"arrow.cpp"
#include"cruiser.cpp"
#include"seeker.cpp"
#include"5shot.cpp"
using namespace std;

SimpleWindow HighScoreWindow("Poket Tank",18,13,Position(3,3));		//window to display highscore

/*names of weapon images in array as to load all weapon one by one using loop
Each weapon is known by index no assiged to them*/
string ImageName[21]={"","wea1.xpm","wea2.xpm","wea3.xpm","wea4.xpm","wea5.xpm","wea6.xpm","wea7.xpm","wea8.xpm","wea9.xpm","wea10.xpm"
,"wea1.xpm","wea2.xpm","wea3.xpm","wea4.xpm","wea5.xpm","wea6.xpm","wea7.xpm","wea8.xpm","wea9.xpm","wea10.xpm"};

/*names of bitmap of terrain to be selected */
string TerrainShapes[4]={"terrain.xpm","hill.xpm","valley.xpm","flat.xpm"};

/*variables which govern the play ,discribed in details at the point of their implementation*/
float cnt1=0.0,cnt2=0.0;
int flag=0,flag2=0,count1=0,Last_BN=-1;

/*the following 4 func are invoked whenever mouse clicks as CLASS MEMBER FUNCTION CANNOT BE PASSED AS ARGUMENT TO SETMOUSECLICKCALLBACK FUNC*/
int NonStaticMemFunc1(const Position &);
int NonStaticMemFunc2(const Position &);
int NonStaticMemFunc3(const Position &);
int NonStaticMemFunc4(const Position &);			

void fire_cpu(int,float,float, int, float*, Position* );		//finds the position of player1 then evaluate corresponding power and angle
float Weapon_Select_Fire(int ,float ,int ,int ,int ,float*,Position*);	//fire the weapon which is selected
float xpos2[2]={50.0,50.0};						//xpos2 and bottomlevel2 used in function drawtank1         
float bottomlevel2[2]={50.0,50.0};       				//for erasing the initially drawn tank before drawing a new one
								
float aimx=50.0,aimy=50.0;						//for erasing the plus bitmap used to show direction
Position linePosition2=Position(50.0,50.0),linePosition1=Position(50.0,50.0);//erasein the line used to show direction

/*This are the gobal variables and function used to draw keyboard shows clicked characters,implimented with ERASE,SPACE,CAPS,ENTER and store name in array ar */
char ar[30],posno=-1;
int No_of_Enter=0;
float X=11,Y=5.0,xcor=0.0;
enum caps {on,off};
caps capslock=off;
const char ch1[40][6]={"1","2","3","4","5","6","7","8","9","0",
		"a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z",
		"SPACE","ERASE","CAPS","ENTER"};	
const char ch2[40][2]={"1","2","3","4","5","6","7","8","9","0",
		"A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"};
void Draw_Keyboard();
void GetName(const Position &);
char GetChar(int,caps);

/*It will ask the name of user and update the present score*/
class PlayerDetails	
{	public:
	char name[30];
	int score;
	PlayerDetails()
	{	score=0;
		strcpy(name,"Computer");
	}
	void ScoreUpdate(float ,int);
	int GetScore(){return score;}
}Computer;

//to maintain maxi bombs
class Bomb
{	int TotalBomb;	
	public:
	int GetTBomb(){return TotalBomb;}
	Bomb(){TotalBomb=20+1;}
};


/*This class will control the functioning of projectile. it will update the power and angles */ 
class Projectile							
{	int Angle;
	int Power;
	public:
	void PutAngle(int add){Angle+=add;}
	void PutPower(int add){Power+=add;}	
	int GetAngle(){
		return Angle;
	}
	int GetPower(){
		return Power;
	}
	Projectile() {
		Angle=0;
		Power=0;
	}
	
};


/* This is the main class which handles the whole game and it also contain the objects of above classes and EZWINDOWS classes.*/ 
class Game
{	PlayerDetails Player1;
	Bomb B;
	Projectile Proj;	
	BitMap Images;	
	int Bomb_Track_C[21],Bomb_Track_P[21];				//keep track of bombs which are selected
	int Bomb_Track_C_Var[21],Bomb_Track_P_Var[21];			//keep track of bombs which are used 
	SimpleWindow &SW;	
		
	public:
	Game();	
	Game(SimpleWindow& w):Images(w),SW(w)
	{	for(int i=0;i<=20;i++)
		{	Bomb_Track_C[i]=Bomb_Track_C_Var[i]=Bomb_Track_P_Var[i]=0;
			Bomb_Track_P[i]=0;
		}
	}
	void Load_BitMap(BitMap &,const Position &);			//takes bitmap, assert,draw
	void DisplayBomb();						//for displaying the available bombs
	int Find_BombNo(const Position &,float,float);			//to find the no of the weapon which is selected when user  for first time
 									//select weapon
	int Find_BombNo1(const Position &,float ,float);		//find weapon's no,erase that bitmap which is selected at the time of play
	void Find_BombNo2(int , float, float);				//erase bitmap of randomly selected weapon by cpu
	void SelectBomb(const Position &,float,float);			//for selecting the various bombs by the players
									//call Find_BombNo and erase corresponding bitmaps and display them on side of 
									//player and cpu,bomb of cpu are randomly selected
	void EraseBomb();						//cleans up tje complete window foe next function
	void ChooseTerrain();						//choose the terrain on which user wants to play
				
	void DisplayTerrain(const Position &);				//display choosen terrain  
	void DisplayPlayBomb();						//display selected (not used)weapons,scores,wind,angle,power
	void Play(const Position &);					//its the main functuon which governs the play	
	void HighScore();						//display top 5 high scores ,stores them in file 
	void ShowPointer(int);						//draws pointer(plus sign)which helps the user to imagine the selected angle
	int Acheck(const Position &);					//checks if click made is on bitmaps of << or >> ,if yes,shows corresponding
									// changes in angle
	int Pcheck(const Position &);					//checks if click made is on bitmaps of << or >> ,if yes,shows corresponding
									//change sin angle

}GameObject(w);

/* It takes the object of bitnap and position . it'll check whether the image has loaded or not and draw the image at the  given position.*/	
void Game::Load_BitMap(BitMap &Image,const Position &Pos)

{
	assert(Image.GetStatus() == BitMapOkay);
	Image.SetPosition(Pos);	
	Image.Draw();
}

/* It'll display the different weapons on screen which will selected by the user
weapon 1 is drawn in row first ,2nd in 2nd row,upto 10 weapon then starts from another column till 10 rows*/
void Game::DisplayBomb()			
{	float varxcor=9.0,varycor=10;					
	EraseBomb();
	SW.RenderRectangle(Position(0,0),Position(SW.GetWidth(),SW.GetHeight()),Black,false);	
	strcpy(Player1.name,ar);
	Images.Load("player.xpm");
	assert(Images.GetStatus()==BitMapOkay);	
	Images.SetPosition(Position(varxcor-5.0,5.0));
	Images.Draw();
	Images.Load("computer.xpm");
	assert(Images.GetStatus()==BitMapOkay);
	Images.SetPosition(Position(varxcor+10.0,5.0));
	Images.Draw();
	for(int j=1,i=1;i<B.GetTBomb();i++,j++)				//looping decrease lines of code to draw images 
	{	if(i==11){j=1;varxcor+=5.0;}				//that's why name of images name are stored in array 
		Images.Load(ImageName[i]);				
		assert(Images.GetStatus()==BitMapOkay);
		Images.SetPosition(Position(varxcor,j+varycor));		
		Images.Draw();
	}
   SW.SetMouseClickCallback(NonStaticMemFunc1);														
}
/*each time fun loads all images ,which are not clicked,set them to their position on which they are drawn,checks wheather click is made inside 
that loaded image,if yes,returns weapon no corresponding to that image,if no,loaed next images and checks again*/
int Game::Find_BombNo(const Position &pos,float varxcor1,float varycor1)					
{	int  i,j=1,x=-1;
	float varxcor=varxcor1;
	for(i=1;i<B.GetTBomb();i++,j++)
	{	if(i==11){varxcor+=5.0;j=1;}
		if((Bomb_Track_P[i]==0) && (Bomb_Track_C[i]==0))
		{	
			Images.Load(ImageName[i]);
			Images.SetPosition(Position(varxcor,j+varycor1));		//cordinate are to be again feed	
			assert(Images.GetStatus()==BitMapOkay);
			if(Images.IsInside(pos)==1)
			{
				x=i;
				break;
			}
		}
	}
	return x;
	
}
/*called after all weapon are drawn,each time when mouse clicks,invokes Find_BombNo to get weapon no which is selected ,erase selected weapon
and draws selected weapon on players side,then cpu randomly generate weapon no which is not being selected by either of player or cpu before
,erase that weapon and draws that to cpu side*/

void Game::SelectBomb(const Position &pos,float varxcor1,float varycor1)
{	
	int BN1,BN,rweano,cou=0;					//BN stores weapon no,BN1 stores row no in which weapon was displayed
									//similarly works rweano for cpu
	float varx=varxcor1,varxcorp=varxcor1,varxcorc=varxcor1;
	
	BN=Find_BombNo(pos,varx,varycor1);
	BN1=BN;
	varxcorp=BN>10?(9+5):9.0;
	BN1=BN1>10?BN1-10:BN1;
	if(BN>0)
	{	Bomb_Track_P[BN]=1;		
		Images.Load(ImageName[BN]);		
		assert(Images.GetStatus()==BitMapOkay);
		Images.SetPosition(Position(varxcorp,BN1+varycor1));		
		Images.Erase();
		SW.RenderRectangle(Position(Images.GetXPosition(),Images.GetYPosition()),Position(Images.GetXPosition()+Images.GetWidth
					(),Images.GetYPosition()+Images.GetHeight()),Black,false);
		Images.SetPosition(Position(varx-5.0,cnt1+varycor1+1.0));		
		Images.Draw();
		while(1)
			{	rweano=rand()%(B.GetTBomb());
				if(rweano>0)
				{	if((Bomb_Track_P[rweano]==0) && (Bomb_Track_C[rweano]==0))
					{	
						break;
					}
				}
			}
		Bomb_Track_C[rweano]=1;
		Images.Load(ImageName[rweano]);		
		varxcorc=rweano>10?(9+5):9.0;
		rweano=rweano>10?rweano-10:rweano;
		Images.SetPosition(Position(varxcorc,rweano+varycor1));		
		Images.Erase();	
		SW.RenderRectangle(Position(Images.GetXPosition(),Images.GetYPosition()),Position(Images.GetXPosition()+Images.GetWidth
					(),Images.GetYPosition()+Images.GetHeight()),Black,false);
		Images.SetPosition(Position(varx+ 10.0,cnt1+varycor1+1.0));
		Images.Draw();
		cnt1+=1.0;
		
	}
	for(int i=1;i<21;i++)if(Bomb_Track_C[i])cou++;
	if(cou==(B.GetTBomb()-1)/2)
	{	usleep(10000);
		EraseBomb();
		ChooseTerrain();
		
	}
}

/* It'll remove all things from the screen whenever we need*/
void Game::EraseBomb()
{	SW.Erase(Position(0.0,0.0),SW.GetWidth(),SW.GetHeight());}

/* It'll give the options for terrain on which user want to play. */ 
void Game::ChooseTerrain()
{	float y=0.0;
	for(int i=0;i<4;i++)
	{	Images.Load(TerrainShapes[i]);
		Load_BitMap(Images,Position(12.0,4.0+y));
		y+=2.0;
	}
	SW.SetMouseClickCallback(NonStaticMemFunc2);
}
/* It'll display the terrain which has been chosen by the user
working of this fun is decribe din details in terrain.cpp*/
void Game::DisplayTerrain(const Position &pos)
{	float trnrand[59],trnstd[59],a,m;
	
	int i=0; float fi=0;
	BitMap terb1(SW),terb2(SW),terb3(SW),terb4(SW);
	terb1.Load("terrain.xpm");					//terb is just name of bitmaps(simple names clash)
	terb2.Load("hill.xpm");
	terb3.Load("valley.xpm");
	terb4.Load("flat.xpm");
	terb1.SetPosition(Position(12.0,4.0));
	terb2.SetPosition(Position(12.0,6.0));
	terb3.SetPosition(Position(12.0,8.0));
	terb4.SetPosition(Position(12.0,10.0));
	if(terb2.IsInside(pos)){m=0.55+0.01*(rand()%21); a=17;}
	if(terb3.IsInside(pos)){m=(-0.7)-0.01*(rand()%21); a=3;	}
	if(terb4.IsInside(pos)){m=0; a=11;}
	if(terb2.IsInside(pos) || terb3.IsInside(pos) || terb4.IsInside(pos))
	{	EraseBomb();
		while(i<57)
		{
			fi=i;
			trnrand[i]=0.01*(rand()%51);
			trnstd[i]=(fi/2)<14?a-m*(fi/2):a-m*(28-(fi/2));
    		trnnet[i]=trnrand[i]+trnstd[i];
			trnpts[i]=Position(fi/2,trnnet[i]);
			i++;
		}
		trnpts[57]=Position(28,21);
		trnpts[58]=Position(0,21);
		w.RenderPolygon(trnpts,59,Green,false);
		drawtank1(3.25,Black,trnnet);
		drawtank1(25.25,Red,trnnet);
		DisplayPlayBomb();
	}
	
}

/* It'll display the weapons selected by player and cpu on their respective sides on game page when main game starts.
displays << and >> bitmaps*/
void Game::DisplayPlayBomb()
{	BitMap powsub1(SW),powsub10(SW),powadd1(SW),powadd10(SW),angsub1(SW),angsub10(SW),angadd1(SW),angadd10(SW),fire_1(SW),angle(SW),power(SW);
	float varxcorp=1.0,varycorp=16.0,varxcorc=SW.GetWidth()-5.0,varycorc=16.0;	
	for(int i=1;i<B.GetTBomb();i++)
	{	if(Bomb_Track_P[i])
		{	Images.Load(ImageName[i]);
			assert(Images.GetStatus()==BitMapOkay);
			Images.SetPosition(Position(varxcorp,varycorp));
			if(!Bomb_Track_P_Var[i])
				Images.Draw();
			
			varycorp+=1.0;
			if(varycorp>=16.0+5.0)
			{	varxcorp+=5.0;
				varycorp=16.0;
			}
		}
		if(Bomb_Track_C[i])
		{	Images.Load(ImageName[i]);
			assert(Images.GetStatus()==BitMapOkay);
			Images.SetPosition(Position(varxcorc,varycorc));
			if(!Bomb_Track_C_Var[i])
				Images.Draw();
			varycorc+=1.0;
			if(varycorc>=16.0+5.0)
			{	varxcorc-=5.0;
				varycorc=16.0;
			}
		}
	}
	powsub1.Load("sub1.xpm");
    	powsub1.SetPosition(Position(12,18.3));        
   	powsub10.Load("sub10.xpm");
    	powsub10.SetPosition(Position(12,19));
	powadd1.Load("add1.xpm");
	powadd1.SetPosition(Position(16.0,18.3));           
	powadd10.Load("add10.xpm");
    	powadd10.SetPosition(Position(16.0,19.0)); 
	angsub1.Load("sub1.xpm");
	angsub1.SetPosition(Position(12.0,19.7));          	
    	angsub10.Load("sub10.xpm");
    	angsub10.SetPosition(Position(12.0,20.4));           
	angadd1.Load("add1.xpm");
	angadd1.SetPosition(Position(16.0,19.7));             
	angadd10.Load("add10.xpm");
    	angadd10.SetPosition(Position(16.0,20.4));
	angle.Load("angle.xpm");
	angle.SetPosition(Position(9,19.7));
	power.Load("power.xpm");	
	power.SetPosition(Position(9,18.3));
	fire_1.Load("fire.xpm");
    	Load_BitMap(fire_1,Position(13.25,17.4));
	powadd1.Draw();powadd10.Draw();powsub1.Draw();powsub10.Draw();angsub1.Draw();angsub10.Draw();angadd1.Draw();angadd10.Draw();power.Draw
	();angle.Draw();  
	wind_gen();
	SW.SetMouseClickCallback(NonStaticMemFunc3);    
}

/*func works same as Find_BombNo only difference is that it returns weapon no which player has used to fire,erase that weapon to show that weapon has been used*/
int Game::Find_BombNo1(const Position &pos,float varxcor1,float varycor1)
{	int  i,x=-1;
	float varxcor=varxcor1,varycor=varycor1;
	for(i=1;i<B.GetTBomb();i++)
	{	if(Bomb_Track_P[i]==1)
		{	Images.Load(ImageName[i]);
			Images.SetPosition(Position(varxcor,varycor));			
			varycor+=1.0;
			if(varycor>=varycor1+5.0)
			{	varxcor+=5.0;
				varycor=varycor1;
			}
			if(Images.IsInside(pos)==1)
			{	x=i;
				Images.Erase();
				SW.RenderRectangle(Position(Images.GetPosition()),Position(Images.GetXPosition()+Images.GetWidth(),Images.GetYPosition()+Images.GetHeight()),Green,false);				
				break;
			}
		}
	}
	return x;
}
/*func works same as Find_BombNo only difference is that it erase weapon selected randomly by cpu,to show that weapon has been used*/
void Game::Find_BombNo2(int pos,float varxcor1,float varycor1)
{	int  i,x=-1;
	float varxcor=varxcor1,varycor=varycor1;
	
	for(i=1;i<B.GetTBomb();i++)
	{	if(Bomb_Track_C[i]==1)
		{	Images.Load(ImageName[i]);
			Images.SetPosition(Position(varxcor,varycor));			
			varycor+=1.0;
			if(varycor>=varycor1+5.0)
			{	varxcor-=5.0;
				varycor=16.0;
			}
			if(i==pos)
			{	Images.Erase();
				SW.RenderRectangle(Position(Images.GetPosition()),Position(Images.GetXPosition()+Images.GetWidth(),Images.GetYPosition(
				)+Images.GetHeight()),Green,false);				
				break;
			}
		}
	}
	
}
/*it takes selected power and angles and weapon no and call respective weapon using switch and returns xcor where weapon had exploded*/
float Weapon_Select_Fire(int Bomb_No,float x,int angle,int power,int wind,float* trnnet,Position* trnpts)
{	int BN=Bomb_No;float xcor;
	
	switch(BN)
	{	case 1:{xcor=Nuke1(x,terrainshape(x,trnnet)-1,angle,power,wind,trnnet,trnpts);break;}
		case 2:{xcor=Cruser1(x,terrainshape(x,trnnet)-1,angle,power,wind,trnnet,trnpts);break;}
		case 3:{xcor=Seeker1(x,terrainshape(x,trnnet)-1,angle,power,wind,trnnet,trnpts);break;}
		case 4:{xcor=Shower1(x,terrainshape(x,trnnet)-1,angle,power,wind,trnnet,trnpts);break;}
		case 5:{xcor=Skipper1(x,terrainshape(x,trnnet)-1,angle,power,wind,trnnet,trnpts);break;}
		case 6:{xcor=Acidrain1(x,terrainshape(x,trnnet)-1,angle,power,wind,trnnet,trnpts);break;}
		case 7:{xcor=Fiveshot1(x,terrainshape(x,trnnet)-1,angle,power,wind,trnnet,trnpts);break;}
		case 8:{xcor=Arrow1(x,terrainshape(x,trnnet)-1,angle,power,wind,trnnet,trnpts);break;}
		case 9:{xcor=Zapper1(x,terrainshape(x,trnnet)-1,angle,power,wind,trnnet,trnpts);break;}
		case 10:{xcor=Wall1(x,terrainshape(x,trnnet)-1,angle,power,wind,trnnet,trnpts);break;}
		
	}
	return xcor;
}
/*func is inkoved whenever there is mouseclick on main playing screen.
it checks the following:wheather click is made on
1.weapons,if yes,call Find_BombNo1 to know weapon no ,store in Bomb_No_P,make Bomb_Track_P_Var[Bomb_No_P]=1 as to
  keep track which weapon is used,assign Last_BN=Bomb_No_P as to know which weapon is selected before fire is clicked
  and make flag=1 indicating weapon has ben selected and no further weapon selection can be done
2.<< or >>,if yes,call Acheck(),Pcheck() to update angle and power 
3.fire,if yes,make flag=0 as to regain power to select bomb
	      calculate distance of explotion from tank which calculate score
	      displays score
	      cpu selectes random weapon fire it display cpu score
	      count1++ to keep track of no of weapons used,if count==10 i.e.all weapon are used
		call highscore()*/
void Game::Play(const Position &pos)
{	BitMap fire_1(SW);
	fire_1.Load("fire.xpm");
    	fire_1.SetPosition(Position(13.25,17.4)); 
	int Bomb_No_P=-1,Bomb_No_C=-1;		
	int achk=Acheck(pos),pchk=Pcheck(pos);	
	if(::flag==0)
	{
		Bomb_No_P=Find_BombNo1(pos,1.0,16.0);
		Bomb_Track_P_Var[Bomb_No_P]=1;
		Last_BN=Bomb_No_P;
	}
		
	if(Bomb_No_P>=0)				//Selecting the weapon to be fired immediately by the player 
	{	::flag=(::flag==0)?1:0;
		
	}
	if(achk)				//Changing the angle of the projectile
	{	Proj.PutAngle(achk);
		ShowPointer(achk);
	}
	if(pchk)				//changing the power of the projectile
	{	Proj.PutPower(pchk);
	}
	if(fire_1.IsInside(pos))
	{	if(::flag==1)
		{	
			float xcord=Weapon_Select_Fire(Last_BN,tank1_x,Proj.GetAngle(),Proj.GetPower(),wind,trnnet,trnpts);
			DisplayPlayBomb();
			displaynum(12.5,19.7,Proj.GetAngle(),Green);	
			displaynum(12.5,18.3,Proj.GetPower(),Green);  
			float Distance=sqrt(pow((xcord-tank2_x),2)+pow((terrainshape(xcord,trnnet)-terrainshape(tank2_x,trnnet)),2));
			Player1.ScoreUpdate(Distance,1);
			displaynum(0,0,Player1.GetScore(),White);
			while(1)
			{	Bomb_No_C=rand()%B.GetTBomb();
				if (Bomb_Track_C[Bomb_No_C]  &&  (!Bomb_Track_C_Var[Bomb_No_C]))
					break;
			}
			Find_BombNo2(Bomb_No_C,SW.GetWidth()-5,16);
			Bomb_Track_C_Var[Bomb_No_C]=1;
			fire_cpu(Bomb_No_C,tank2_x,terrainshape(tank2_x,trnnet)-1,wind,trnnet,trnpts);
			count1++;
			DisplayPlayBomb();
			displaynum(25,0,Computer.GetScore(),White);
			displaynum(12.5,19.7,Proj.GetAngle(),Green);	
			displaynum(12.5,18.3,Proj.GetPower(),Green); 
			
			flag=0;
			
			if(count1==10) {
				usleep(1000000);
				HighScore();
			}
		}
	}
}	
/* This func takes the records(from file Highscore.txt) of the initial top 5 high-scorers into the array top[]. Then it compares the score of the current player (whose record was stored as Player1) with those of the earlier toppers. Then it accordingly decides the final top 5 scorers and stores them in top[] and again writes the array into the taxt file. Thn it also displays the final 5 top scorers on the window */
void Game::HighScore()
{	const char sno[5][5]={"1.","2.","3.","4.","5."};
const char sc[501][5]= {"0","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20"
,"21","22","23","24","25","26","27","28","29","30","31","32","33","34","35","36","37","38","39","40"
,"41","42","43","44","45","46","47","48","49","50","51","52","53","54","55","56","57","58","59","60"
,"61","62","63","64","65","66","67","68","69","70","71","72","73","74","75","76","77","78","79","80"
,"81","82","83","84","85","86","87","88","89","90","91","92","93","94","95","96","97","98","99","100"
,"101","102","103","104","105","106","107","108","109","110","111","112","113","114","115","116","117","118","119","120"
,"121","122","123","124","125","126","127","128","129","130","131","132","133","134","135","136","137","138","139","140"
,"141","142","143","144","145","146","147","148","149","150","151","152","153","154","155","156","157","158","159","160"
,"161","162","163","164","165","166","167","168","169","170","171","172","173","174","175","176","177","178","179","180"
,"181","182","183","184","185","186","187","188","189","190","191","192","193","194","195","196","197","198","199","200"
,"201","202","203","204","205","206","207","208","209","210","211","212","213","214","215","216","217","218","219","220"
,"221","222","223","224","225","226","227","228","229","230","231","232","233","234","235","236","237","238","239","240"
,"241","242","243","244","245","246","247","248","249","250","251","252","253","254","255","256","257","258","259","260"
,"261","262","263","264","265","266","267","268","269","270","271","272","273","274","275","276","277","278","279","280"
,"281","282","283","284","285","286","287","288","289","290","291","292","293","294","295","296","297","298","299","300"
,"301","302","303","304","305","306","307","308","309","310","311","312","313","314","315","316","317","318","319","320"
,"321","322","323","324","325","326","327","328","329","330","331","332","333","334","335","336","337","338","339","340"
,"341","342","343","344","345","346","347","348","349","350","351","352","353","354","355","356","357","358","359","360"
,"361","362","363","364","365","366","367","368","369","370","371","372","373","374","375","376","377","378","379","380"
,"381","382","383","384","385","386","387","388","389","390","391","392","393","394","395","396","397","398","399","400"
,"401","402","403","404","405","406","407","408","409","410","411","412","413","414","415","416","417","418","419","420"
,"421","422","423","424","425","426","427","428","429","430","431","432","433","434","435","436","437","438","439","440"
,"441","442","443","444","445","446","447","448","449","450","451","452","453","454","455","456","457","458","459","460"
,"461","462","463","464","465","466","467","468","469","470","471","472","473","474","475","476","477","478","479","480"
,"481","482","483","484","485","486","487","488","489","490","491","492","493","494","495","496","497","498","499","500"};	
	fstream f;
	PlayerDetails top[6],temp,P;
	int cnt;char varchar;
	f.open("Highscore.txt",ios::in);
	//f.seekg(ios::beg);	
	if (f== NULL) 
	{ 
		
		
	}
	//Inputs the initial highscores from the file records.txt
	for(cnt=0;cnt<5;cnt++) 
	{	if(!f.eof()) {
		f>>top[cnt].name>>top[cnt].score;//cin.get(varchar);
		
		}
	}
	f.close();
	//fin.close();
	//Adds the record of new highscorer and sorts all the records on the basis of their scores
	for(cnt=0;cnt<5;cnt++) 
	{
		if(Player1.score>top[cnt].score) 
		{
			for(int i=6;i>cnt;i--)
				top[i]=top[i-1];
			top[cnt]=Player1;
			break;
		}
	}
	f.open("Highscore.txt",ios::out|ios::in);
	//fout.open("highscore.txt");
	//Again writes the final top 5 scorers into the file Highscore.txt
	//f.seekp(ios::beg);
	for(cnt=0;cnt<5;cnt++) 
	{
		f<<top[cnt].name<<endl<<top[cnt].score;
		
	}
	//fout.close();
	//high score window opens
	//SW.RenderRectangle(Position(0.0,0.0),Position(18.0,13.0),Black);
	
	HighScoreWindow.Open();
	//fin.open("highscore.txt");
	HighScoreWindow.RenderRectangle(Position(0,0),Position(18,13),Black,false);
	HighScoreWindow.RenderText(Position(3,3),"Rank",White,Black);
	HighScoreWindow.RenderText(Position(5,3),"Name",White,Black);
	HighScoreWindow.RenderText(Position(15,3),"Score",White,Black);
	//f.seekg(ios::beg);
	for(int i=0;i<5;i++) 
	{	f>>P.name>>P.score;
		
		HighScoreWindow.RenderText(Position(3,5+i),sno[i],Green,Black);
		HighScoreWindow.RenderText(Position(5,5+i),top[i].name,Green,Black);
		HighScoreWindow.RenderText(Position(15,5+i),sc[top[i].score],Green,Black);
	}
	f.close();
}
/* it is well explained in score&buttons.cpp*/
void Game::ShowPointer(int add)
{	BitMap aim(SW);	aim.Load("aim.xpm");
	aim.SetPosition(Position(aimx,aimy));
	if(flag2)aim.Erase();
	w.RenderLine(linePosition1,linePosition2,White,0.05);
    aim.SetPosition(Position(tank1_x+2*cos((Proj.GetAngle()+add)*3.141592/180)-0.2,terrainshape(tank1_x,trnnet)-0.7-2*sin((Proj.GetAngle()+add)         	*3.141592/180)-0.2));
	aimx=tank1_x+2*cos((Proj.GetAngle()+add)*3.141592/180)-0.2;
	aimy=terrainshape(tank1_x,trnnet)-0.7-2*sin((Proj.GetAngle()+add)*3.141592/180)-0.2;
	aim.Draw();
	flag2=1;
	w.RenderLine(Position(tank1_x,terrainshape(tank1_x,trnnet)-0.7),Position(tank1_x+0.5*cos((Proj.GetAngle()+add)*3.141592/180),terrainshape(tank1_x,trnnet)-0.7-0.5*sin((Proj.GetAngle()+add)*3.141592/180)),Blue,0.05);
	linePosition1=Position(tank1_x,terrainshape(tank1_x,trnnet)-0.7);
	linePosition2=Position(tank1_x+0.5*cos((Proj.GetAngle()+add)*3.141592/180),terrainshape(tank1_x,trnnet)-0.7-0.5*sin((Proj.GetAngle()+add)*3.141592/180));
}

/* It will detect that if user will click on perticular tab then it'll work according to where mouse has been click.basically it will handle the angles and update it and shows updated angle on main play window and return changes made in angle */
int Game::Acheck(const Position &pos)		 
{	angsub1.Load("sub1.xpm");
    	angsub1.SetPosition(Position(12.0,19.7));          	
    	angsub10.Load("sub10.xpm");
    	angsub10.SetPosition(Position(12.0,20.4));           
	angadd1.Load("add1.xpm");
	angadd1.SetPosition(Position(16.0,19.7));             
	angadd10.Load("add10.xpm");
	angadd10.SetPosition(Position(16.0,20.4));
	if(angsub1.IsInside(pos))
	{	if(Proj.GetAngle()>-180)
    	{	displaynum(12.5,19.7,Proj.GetAngle()-1,Green);
			return -1;
		}
		else
		{	displaynum(12.5,19.7,Proj.GetAngle(),Green);	
			return 0;
		}
	}
	
	if(angadd1.IsInside(pos))
	{	if(Proj.GetAngle()<180)
    	{	displaynum(12.5,19.7,Proj.GetAngle()+1,Green);
			return 1;
		}
		else 
		{	displaynum(12.5,19.7,Proj.GetAngle(),Green);
			return 0;
		}
	}
	if(angsub10.IsInside(pos))
	{	if(Proj.GetAngle()>=-180)
    	{	displaynum(12.5,19.7,Proj.GetAngle()-10,Green);
			return -10;
		}
		else 
		{	displaynum(12.5,19.7,Proj.GetAngle(),Green);
			return 0;
		}
	}	
	
	if(angadd10.IsInside(pos))
	{	if(Proj.GetAngle()<=170)
    	{	displaynum(12.5,19.7,Proj.GetAngle()+10,Green);
			return 10;
		}
		else 	
		{	displaynum(12.5,19.7,Proj.GetAngle(),Green);
			return 0;
		}
	}
	return 0;
}

/*Its same as above function. it'll change the power */ 
int Game::Pcheck(const Position &pos)		
{	powsub1.Load("sub1.xpm");
    	powsub1.SetPosition(Position(12,18.3));        
    	powsub10.Load("sub10.xpm");
    	powsub10.SetPosition(Position(12,19));
	powadd1.Load("add1.xpm");
	powadd1.SetPosition(Position(16.0,18.3));           
	powadd10.Load("add10.xpm");
    	powadd10.SetPosition(Position(16.0,19.0)); 
	if(powsub1.IsInside(pos))             //The tab for decreasing power is Pless.xpm and for opposite Pmore.xpm
	{	if(Proj.GetPower()>0)
    	{	displaynum(12.5,18.3,Proj.GetPower()-1,Green);
			return -1;
		}
		else 
		{	displaynum(12.5,18.3,Proj.GetPower(),Green);
			return 0;
		}
	}
	if(powadd1.IsInside(pos))
	{	if(Proj.GetPower()<100)
    	{	displaynum(12.5,18.3,Proj.GetPower()+1,Green);
			return 1;
		}
		else 
		{	displaynum(12.5,18.3,Proj.GetPower(),Green);
			return 0;
		}
		return 1;
	}
	if(powsub10.IsInside(pos))             //The tab for decreasing power is Pless.xpm and for opposite Pmore.xpm
	{	if(Proj.GetPower()>=10)
    	{	displaynum(12.5,18.3,Proj.GetPower()-10,Green);
			return -10;
		}
		else	
		{	displaynum(12.5,18.3,Proj.GetPower(),Green);
			return 0;
		}
	}
	if(powadd10.IsInside(pos))
	{	if(Proj.GetPower()<=90)
    	{	displaynum(12.5,18.3,Proj.GetPower()+10,Green);
			return 10;
		}
		else 
		{	displaynum(12.5,18.3,Proj.GetPower(),Green);
			return 0;
		}
	}
	return 0;
}
/*game starts from here*/
void oneplayergame()
{	w.Open();
	assert(w.GetStatus()==WindowOpen);
	
	Draw_Keyboard();
	w.SetMouseClickCallback(NonStaticMemFunc4);										
}
/*called when mouceclick on weapon selection page*/
int NonStaticMemFunc1(const Position &pos)
{	
	GameObject.SelectBomb(pos,9.0,10.0);
	
	return 1;
}
/*called when mouceclick on terrain selection page*/
int NonStaticMemFunc2(const Position &pos)
{	GameObject.DisplayTerrain(pos);
	return 1;
}
/*called when mouceclick on main play page*/
int NonStaticMemFunc3(const Position &pos)
{	GameObject.Play(pos);
	return 1;
}
/*called when mouseclickes on keyboard*/
int NonStaticMemFunc4(const Position &pos)
{	GetName(pos);
	if(No_of_Enter)
	{	GameObject.DisplayBomb();
	}
}
/*it is copied from trn_works.cpp*/
void editterrain(float xblast,float yblast,float blastrange,float* trnnet,Position* trnpts){
  float fi; float yc;int i;
    for(i=1+2*(xblast-blastrange);i<=2*(xblast+blastrange);i++){
	fi=i;
	yc=sqrt(blastrange*blastrange-(xblast-fi/2)*(xblast-fi/2));
		if(trnnet[i]<=yblast-yc){
			trnnet[i]+=2*yc;
		}
		else {
			if(trnnet[i]>=yblast+yc){//trnnet[i]=trnnet[i];
			   } 
			else {trnnet[i]=yblast+yc;
			   }
			trnpts[i]=Position(fi/2,trnnet[i]);
		  }
  }
	w.RenderPolygon(trnpts,59,Green,false);	
	drawtank1(tank1_x,Black,trnnet);
	drawtank1(tank2_x,Red,trnnet);
}
/*it draws tank(a box) at given xcordinate ,of given color*/
void drawtank1(float xpos, color c, float* trnnet1)
{ 	w.RenderRectangle(Position(xpos2[0]-0.5,bottomlevel2[0]-0.7),Position(xpos2[0]+0.5,bottomlevel2[0]),White,false);	
	float bottomlevel;
	bottomlevel=terrainshape(xpos,trnnet);
	w.RenderRectangle(Position(xpos-0.5,bottomlevel-0.7),Position(xpos+0.5,bottomlevel),c,false);
	/*we store the coordinates of initial two tanks as we have two erase the tank which was drawn second-last*/
  	xpos2[0]=xpos2[1];
	xpos2[1]=xpos;
	bottomlevel2[0]=bottomlevel2[1];
	bottomlevel2[1]=bottomlevel;	
}
/*it calculate power and angle for firing by cpu
 logic:for particular angle it calculates power on basis of position of palyer's tank 
       now, with given power and angle it checks wheather trajetory hits terrai in way to player's tank
	if no,it fires with that angle and power
	if yes,it fires at angle of 60 and correspondin power*/
void fire_cpu(int Bomb_No_C,float x_fp,float y_fp, int wind, float trnnet[], Position trnpts[])
{	float tank1x=3.25,xcord,Distance;
	float tank1y=terrainshape(tank1x,trnnet)-0.7;
	int phi=70,power,count=0; float P,theta,t,x,y;
	float a1=x_fp-tank1x ,a2 ,a3 ,b1=y_fp-tank1y,b2,b3;
	while(phi<150)
	{	theta=phi*3.141592/180;
		a2=0.14*cos(theta); b2=-0.14*sin(theta);
		a3=.5*.02*wind; b3=1.9;
		if((a2*b1-a1*b2)/(a3*b2-b3*a2)<0 || (a3*b1-a1*b3)/(a2*b3-b2*a3)<0){phi+=1; continue;}
		t=sqrt((a2*b1-a1*b2)/(a3*b2-b3*a2));
		P=((a3*b1-a1*b3)/(a2*b3-b2*a3))/t;
		power=P;
		for(float i=0; 1; i+=0.1)
		{	x=x_fp+0.14*power*cos(theta)*i+0.5*.02*wind*i*i;
			y=y_fp-0.14*power*sin(theta)*i+1.9*i*i;
			if(y>=terrainshape(x,trnnet)){break;}
		}
	
		if(abs(x-tank1x)<0.2 && power>0 && power<100)
		{	displaynum(12.5,19.7,phi,Green);	
			displaynum(12.5,18.3,power,Green);  
			xcord=Weapon_Select_Fire(Bomb_No_C,x_fp, phi, power-3+(-5+rand()%10), wind, trnnet, trnpts); count++;// whichever is selected
			Distance=sqrt(pow((xcord-tank1_x),2)+pow((terrainshape(xcord,trnnet)-terrainshape(tank1_x,trnnet)),2));
			Computer.ScoreUpdate(Distance,1);
			break;
		}
		else{phi+=1;}
	}
	if(count==0)
	{	xcord=Weapon_Select_Fire(Bomb_No_C,x_fp, 60, 50, wind, trnnet, trnpts);
		Distance=sqrt(pow((xcord-tank1_x),2)+pow((terrainshape(xcord,trnnet)-terrainshape(tank1_x,trnnet)),2));
		Computer.ScoreUpdate(Distance,1);
	}
}
/*scoreupdate is copied from score&buttons.cpp*/
void PlayerDetails::ScoreUpdate(float distance, int weaponnumber){
   int point_added;
   float dieoffdistance, accuracy;
   int max_points;
	if (weaponnumber==1){dieoffdistance=2.4;accuracy=0.7;max_points=160;}  //nuke
	if (weaponnumber==2){dieoffdistance=0.7;accuracy=0.5;max_points=50;}  //cruiser
	if (weaponnumber==3){dieoffdistance=1;accuracy=0.5;max_points=60;}  //seeker
	if (weaponnumber==4){dieoffdistance=0.8;accuracy=1.2;max_points=25;}  //meteor shower
	if (weaponnumber==5){dieoffdistance=1.2;accuracy=3;max_points=80;}  //skipper
	if (weaponnumber==6){dieoffdistance=5;accuracy=1;max_points=70;}  //acid rain
	if (weaponnumber==7){dieoffdistance=1;accuracy=1.5;max_points=20;}  //five shot
	if (weaponnumber==8){dieoffdistance=1.6;accuracy=1.5;max_points=70;}  //arrow
	if (weaponnumber==9){dieoffdistance=1.6;accuracy=1;max_points=50;}  //zapper
	if (weaponnumber==10){dieoffdistance=5;accuracy=1;max_points=0;}  //wall

   	if (distance<=dieoffdistance)
	{
	        score+=(float) max_points*(1-pow((distance/dieoffdistance),accuracy));
	}
	
	
}
/*it draws keyboard i.e. table of 4 rows 10 column .each cell correspond to diffrent key and each cell is identified by no 1-40 moving horizontally*/
void Draw_Keyboard()
{	int k=0;
	float b=w.GetWidth()/10;
	float h=w.GetHeight()/16;
	float x=0.0,y=w.GetHeight()*3/4;	
	w.RenderRectangle(Position(0,0),Position(w.GetWidth(),w.GetHeight()),Black,true);	
	BitMap name(w);name.Load("player.xpm");assert(name.GetStatus()==BitMapOkay);name.SetPosition(Position(11,2));name.Draw();
	for(float j=y;j<=(w.GetHeight()-h);j+=h)
	{	
		for(float i=x;i<=(w.GetWidth()-b)+1;i+=b)
		{	
			w.RenderRectangle(Position(i,j),Position(i+b,j+h),Green,true);
			w.RenderText(Position(i+b/2,j+h/2),ch1[k],Black,Green);
			++k;
		}
	}  
}
/*it takes podition of mouseclick ,find rowno and colno i.e.cell no(chart)
chart==40:ENTER No_of_Enter keep track of no of times enter is clicked
chart==39:CAPSLOCK switch on to off and vice-versa
chart==38:ERASE 
chart==37:SPACE
ELSE :KEYS
X ,Y are macros
xcor ,global variable,keep track of pointer which decide the position of text to be drawn
posno,global variable,keep track of pointer which decide the position of text to be store*/
void GetName(const Position &pos)
{	float x=pos.GetXDistance(),y=pos.GetYDistance(),yadd=0;
	float b=w.GetWidth()/10;
	float h=w.GetHeight()/16;
	
	if(y>=w.GetHeight()*3/4)
	{	int coln=int(x/b)+1,rown=int((y-(w.GetHeight()*3/4))/h);
		int chart=10*rown+coln;
		
		if(chart==40)
		{	++No_of_Enter;
		}		
		else if(chart==38)
		{	if(posno>0) 
			{	ar[posno]='\0';
				--posno;
		 		w.RenderText(Position(X+xcor,Y),Position(X+xcor+0.5,Y+0.5)," ",Black,Black);
				xcor-=0.5;
			}
		}
		else if(chart==37)
		{	++posno;xcor+=0.5;
			ar[posno]=32;
			w.RenderText(Position(X+xcor,Y),Position(X+xcor+0.5,Y+0.5)," ",Black,Black);
		}
		else if(chart==39)
		{	if(capslock==off)capslock=on;
			else			 capslock=off;
		}
		else 
		{	if(posno<30)
			{	if(capslock==on) 
				{	++posno;xcor+=0.5;
					ar[posno]=GetChar(chart,on);
				}
				else
				{	++posno;xcor+=0.5;
					ar[posno]=GetChar(chart,off);
				}
				if(No_of_Enter)yadd=2.0;
				if(chart<39)
					{if(capslock==on)w.RenderText(Position(X+xcor,Y+yadd),Position(X+xcor+0.5,Y+yadd+0.5),ch2[chart-1],White,Black);
					else		w.RenderText(Position(X+xcor,Y+yadd),Position(X+xcor+0.5,Y+yadd+0.5),ch1[chart-1],White,Black);}
			}
		}
	}
		
	
}
/*return char corresponding to key at cell no chart on basis of capslock mode*/
char GetChar(int chart,caps capslock)
{	char ch1[41]="1234567890abcdefghijklmnopqrstuvwxyzSBCE";
	char ch2[41]="1234567890ABCDEFGHIJKLMNOPQRSTUVWXYZ";
	if(capslock==on)	return ch2[chart-1];
	else				return ch1[chart-1];
	
}






